""" unit format strings for netCDF variables. """

NC_UNITS_FORMAT = {
    "2D_cumulative_well_flux": "{0}^3/{1}",
    "3D_cumulative_well_flux": "{0}^3/{1}",
    "al": "{0}/{0}",
    "botm": "{0}",
    "cell_by_cell_flow": "{0}^3/{1}",
    "chd_ehead": "{0}",
    "chd_shead": "{0}",
    "delc": "{0}",
    "delr": "{0}",
    "drawdown": "{0}",
    "drn_cond": "{0}^2/{1}",
    "drn_elev": "{0}",
    "dz": "{0}",
    "elevation": "{0}",
    "ghb_bhead": "{0}",
    "ghb_cond": "{0}^2/{1}",
    "hani": "{0}/{0}",
    "head": "{0}",
    "hk": "{0}/{1}",
    "horizontal_hydraulic_conductivity": "{0}/{1}",
    "mnw2_B": "{1}/{0}^2",
    "mnw2_C": "{1}^P/{0}^(3P-1)",
    "mnw2_P": "dimensionless",
    "mnw2_capmult": "dimensionless",
    "mnw2_cprime": "concentration units",
    "mnw2_cwc": "{0}^2/{1}",
    "mnw2_hlift": "{0}",
    "mnw2_hlim": "{0}",
    "mnw2_hwtol": "{0}",
    "mnw2_kskin": "{0}/{1}",
    "mnw2_liftn": "{0}",
    "mnw2_liftq0": "{0}",
    "mnw2_liftqmax": "{0}",
    "mnw2_pp": "{0}/{0}",
    "mnw2_qcut": "{0}^3/{1}",
    "mnw2_qdes": "{0}^3/{1}",
    "mnw2_qfrcmn": "fraction",
    "mnw2_qfrcmx": "fraction",
    "mnw2_qn": "{0}^3/{1}",
    "mnw2_rskin": "{0}",
    "mnw2_rw": "{0}",
    "mnw2_zbotm": "{0}",
    "mnw2_zpump": "{0}",
    "mnw2_ztop": "{0}",
    "model_top": "{0}",
    "primary_storage_coefficient": "{0}/{0}",
    "prsity": "{0}/{0}",
    "rech": "{0}/{1}",
    "riv_cond": "{0}^2/{1}",
    "riv_rbot": "{0}",
    "riv_stage": "{0}",
    "sconc1": "concentration units",
    "sfr_rchlen": "{0}",
    "sfr_slope": "{0}/{0}",
    "sfr_strhc1": "{0}/{1}",
    "sfr_strthick": "{0}",
    "sfr_strtop": "{0}",
    "sfr_thti": "{0}/{0}",
    "sfr_thts": "{0}/{0}",
    "sfr_uhc": "{0}/{1}",
    "ss": "1/{0}",
    "strt": "{0}",
    "subsidence": "{0}",
    "sy": "{0}/{0}",
    "thickness": "{0}",
    "time": "{1}",
    "top": "{0}",
    "transmissivity": "{0}^2/{1}",
    "vertical_conductance": "{0}^2/{1}",
    "vka": "{0}/{1} or fraction",
    "vkcb": "{0}/{1}",
    "wel_flux": "{0}^3/{1}",
}
